#ModelSwarm.py
import Tools
from Bug import *
from ActionGroup import *
import random

f=""
task="0 0".split()

class ModelSwarm:
    def __init__(self, nBugs, worldXSize, worldYSize):
        # the environment
        self.nBugs = nBugs
        self.bugList = []

        self.worldXSize= worldXSize
        self.worldYSize= worldYSize
        

        self.share=0

        execfile("convert_xls_txt.py")

    # objects
    def buildObjects(self):
        for i in range(self.nBugs):
            aBug = Bug(i, random.randint(0,self.worldXSize-1), 
                    random.randint(0,self.worldYSize-1), self.worldXSize,
                    self.worldYSize)
            self.bugList.append(aBug)
        print

    # actions
    def buildActions(self):

        self.actionGroup1 = ActionGroup ("move")
        def do1(address):

            actionDictionary[self.actionGroup1.getName()]=self.actionGroup1

            # keep safe the original list
            address.bugListCopy=address.bugList[:]
            # never in the same order (please comment if you want to keep
            # always the same sequence
            random.shuffle(address.bugListCopy)
            # move with a jump, to have to transfer a parameter
            # the format is: collection, method, parameters by name
            # ask each agent, without parameters
            # the potential jump is the same for all the agents
            askEachAgentIn(address.bugListCopy,Bug.randomWalk,
                                        jump=random.uniform(0,5))

            self.actionGroup1.execLocalCode()

        self.actionGroup1.do = do1 # do is a variable linking a method

        self.actionGroup2 = ActionGroup ("schedule")
        def do2(address, cycle):
            global task

            actionDictionary[self.actionGroup2.getName()]=self.actionGroup2

            while True:
                if task[0]=="#":
                    if int(task[1]) > cycle: break

                task=read_s(f)
                #print "***", task

                if task[0]=="#":
                    if int(task[1]) > cycle: break
                if task[0]=="0": break

                if task[0]=='Bug':
                    # keep safe the original list
                    localList=address.bugList[:]
                    # never in the same order (please comment if you want to keep
                    # always the same sequence
                    random.shuffle(localList)
                    # apply method only to a share of the list
                    self.share=0
                    try:    self.share = float(task[1]) # does task[1] contains
                                                        # a number?
                    except: pass
                    
                    if self.share > 0:
                        tmpList=localList[:]
                        del localList[:]
                        for i in range(len(tmpList)):
                            if random.random() <= self.share:
                                localList.append(tmpList[i])
                    # apply
                    if len(localList)>0:
                        self.applyFromSchedule(localList,task)
                   

        self.actionGroup2.do = do2 # do is a variable linking a method
    
    

        # basic schedule, where "move" represents an example of mandatory
        # action (in our case generating also a dynamic "jump" action) and
        # "read_schedule" represents an external source of actions
        self.actionList = [["move", "read_schedule"]]

        # or, without reading the external schedule (anyway, in the case
        # above, if you do not put a schedule.txt or a schedule.xls file in
        # program folder, the "read_schedule" step simply has no effect)
        #self.actionList = [["move"]]

        # self.actionList = [["move", "read_schedule"]]
        # or
        # self.actionList = [["move"], ["read_schedule"]]
        # have the same effect


    # run a step
    def step(self,cycle):
            global f, task

            step=extractAStepAndRotate(self.actionList)

            while len(step)>0:
                subStep=extractASubStep(step)


                if subStep == "move":
                        self.actionGroup1.do(self)
                    # self here is the model env.
                    # not added automatically
                    # being do a variable
                    

                if subStep == "read_schedule":
                        if f=="":
                            try: f=open("./schedule.txt","r")
                            except: pass
                        self.actionGroup2.do(self,cycle)
                    # self here is the model env.
                    # not added automatically
                    # being do a variable


    # from external schedule
    def applyFromSchedule(self,localList,task):
        if self.share>0:
            exec "askEachAgentIn(localList,"+task[0]+"."+task[2]+")"
        else:
            exec "askEachAgentIn(localList,"+task[0]+"."+task[1]+")" 

    # bug list
    def getBugList(self):
        return self.bugList

    # file address
    def getFile(self):
        global f
        return f

# tools, read_s
def read_s(f):
    if f != "":
        try:
            task=f.readline()
            if task=='':task='0 0'
        except:
            task='0 0'
    else: task='0 0'

    return task.split()
